C**********************************************************                  LSCRN.2     
C             SUBROUTINE LSCRN                                               LSCRN.3     
C**********************************************************                  LSCRN.4     
      SUBROUTINE LSCRN                                                       LSCRN.5     
C                                                                            LSCRN.6     
C  GRID SCALE CONDENSATION TO SATURATION FOR PRESENT LATITUDE.               LSCRN.7     
C  The cloud diagnostic scheme is based on Slingo (1987).                    LSCRN.8     
C  Cloud fractions computed for Low (sigma>0.7),                             LSCRN.9     
C  mid(0.7>sigma>0.35) and  high (0.35>sigma>0.12) cloud                     LSCRN.10    
C  types. Shallow convective and deep convective cloud fractions             LSCRN.11    
C  computed in CUBM and LBADJ respectively.                                  LSCRN.12    
                                                                             LSCRN.13    
C                                                                            PARAM1.2     
C     Determines model resolution                                            PARAM1.3     
C                                                                            PARAM1.4     
      PARAMETER(NN=21,MM=21,NHEM=2,NL=5,MOCT=1,MG=64,JG=16,NWJ2=121          NETCDF.35    
     P         ,NCRAY=64,JGL=JG,NTRAC=1,NLEVRF=1)                            NETCDF.36    
                                                                             PARAM1.7     
C                                                                            PARAM1.8     
C                                                                            PARAM2.2     
C     Sets basic constants, especially those needed for array dimensions     PARAM2.3     
C                                                                            PARAM2.4     
      PARAMETER(MH=2,PI=3.14159265359,PI2=2.0*PI                             PARAM2.5     
     +,NNP=NN+1,MGPP=MG+2,JGP=JG+1,JGG=JG*NHEM,JGGP=JGG+1,MJP=NWJ2+NWJ2      PARAM2.6     
     +,NLM=NL-1,NLP=NL+1,NLPP=NL+2,NLA=NL+3,NLB=NL+4,NL2=NL*NL               PARAM2.7     
     +,IDA=(MG+MG+MG)/2+1,IDB=NWJ2*NL,IDC=IDB+IDB,IDD=MGPP*NL                PARAM2.8     
     +,IDE=NL2*NN,IDF=NCRAY*(MG+1),IDG=JG*NL,IDH=JG*MG                       PARAM2.9     
     +,IDI=NNP/2,IDJ=IDI*IDI,IDK=NL*IDI,IDL=MGPP/2,IDM=NNP/2,IDN=IDM*NL      PARAM2.10    
     +,NWW=1+(MM-1)/MOCT)                                                    PARAM2.11    
      PARAMETER(IGA=NWJ2*NHEM,IGB=IDB*NHEM,IGC=MGPP*NHEM,IGD=IDD*NHEM        PARAM2.12    
     +,IGG=IDG*NHEM,IGL=IDL*NHEM,IGM=IDM*NHEM,IGN=IDN*NHEM                   PARAM2.13    
     +,IGO=IGA+IGA,IGP=IGB+IGB,NFTWG=(5+NTRAC)*NL+3                          PARAM2.14    
     +,NFTGW=(6+3*NTRAC)*NL+2,NFTGD=(3+NTRAC)*NL,NLTR=NL*NTRAC)              PARAM2.15    
C     Number of 2D (surface) output fields. This value is                    PARAM2.16    
C     Doubled due to averaged and instantaneous fields.                      PARAM2.17    
      PARAMETER (N2DFLD=21,NGRPAD=N2DFLD*2*IGC)                              PARAM2.18    
C                                                                            PARAM2.19    
C                                                                            BLANK.2     
C     Basic planetary parameters for run plus information about              BLANK.3     
C     vertical grid structure                                                BLANK.4     
C                                                                            BLANK.5     
C     Note that RD and GASCON are identical and CPD is set from RD,AKAP.     BLANK.6     
      COMMON        SQ(NNP),RSQ(NNP),SIGMAH(NLM),SIGMA(NL)                   BLANK.7     
     +              ,T01S2(NLM),T0(NL),ALPHA(NL),DSIGMA(NL),RDSIG(NL)        BLANK.8     
     +              ,TKP(NL),C(NL2),SQH(NNP)                                 BLANK.9     
     +              ,MF,MFP,JZF,NF,NFP                                       BLANK.10    
     +              ,AKAP,GA,GASCON,RADEA,WW,P0,PFAC,EZ,AIOCT                BLANK.11    
     +              ,RD,RV,CPD,CLATNT                                        BLANK.12    
     +              ,LRSTRT,LSHORT,LTVEC,LSTRETCH                            BLANK.13    
     +              ,LFLUX                                                   BLANK.14    
     +              ,LBALAN,LRESTIJ                                          BLANK.15    
     +              ,LCLIM, LPERPET, L22L,LOROG ,LCSFCT                      BLANK.16    
     +              ,LNOISE                                                  BLANK.17    
      COMPLEX EZ,AIOCT                                                       BLANK.18    
      LOGICAL LRSTRT,LSHORT,LTVEC,LSTRETCH,LBALAN,LRESTIJ                    BLANK.19    
     +       ,LFLUX,LNOISE                                                   BLANK.20    
     +       ,LCLIM, LPERPET, L22L,LOROG,LCSFCT                              BLANK.21    
C                                                                            BLANK.22    
C                                                                            LEGAU.2     
C     Legendre polynomials and information about gaussian latitudes          LEGAU.3     
C                                                                            LEGAU.4     
      COMMON/LEGAU/ ALPJ(MJP),DALPJ(MJP)                                     LEGAU.5     
     +              ,ALP(NWJ2,2,JGL),DALP(NWJ2,2,JGL)                        LEGAU.6     
     +              ,RLP(NWJ2,2,JGL),RDLP(NWJ2,2,JGL)                        LEGAU.7     
     +              ,SI(JGG),CS(JGG),SISQ(JGG),CSSQ(JGG),SECSQ(JGG)          LEGAU.8     
     +              ,ALAT(JGG),GWT(JGG),AW(JGG),JH,JL,JINC                   LEGAU.9     
C                                                                            LEGAU.10    
C                                                                            GRIDPP.2     
C     Array ordering in GRIDP must correspond to that in SPECTR.             GRIDPP.3     
C     Real arrays: multi-level arrays are 2-dimensional.                     GRIDPP.4     
C     the variables have been renamed to coincide with                       GRIDPP.5     
C     variable names in bgcm5 DGRMLT                                         GRIDPP.6     
C                                                                            GRIDPP.7     
C swapped round VLNG and UNLG to check                                       GRIDPP.8     
      COMMON/GRIDP/ CHIG(IGC,NL),SFG(IGC,NL),UG(IGC,NL),VG(IGC,NL)           GRIDPP.9     
     :              ,TTVD(IGC,NL),QTVD(IGC,NL),TG(IGC,NL)                    GRIDPP.10    
     :              ,TRAG(IGC,NL,NTRAC)                                      GRIDPP.11    
     :              ,PLG(IGC),TYBL(IGC),TXBL(IGC)                            GRIDPP.12    
     :              ,SPG(IGC),VPG(IGC),TTRD(IGC,NL)                          GRIDPP.13    
     :              ,TNLG(IGC,NL),TRANLG(IGC,NL,NTRAC),UNLG(IGC,NL)          GRIDPP.14    
     :              ,VNLG(IGC,NL),TTLR(IGC,NL),UTRAG(IGC,NL,NTRAC)           GRIDPP.15    
     :              ,TTCR(IGC,NL),VTRAG(IGC,NL,NTRAC)                        GRIDPP.16    
     :              ,UTVD(IGC,NL),VTVD(IGC,NL)                               GRIDPP.17    
     :         ,ASSBL(IGC),ASHBL(IGC),ASLBL(IGC),ARRCR(IGC),ARRLR(IGC)       GRIDPP.18    
     :         ,arflux(igc,6),asfld(igc,6),acld(igc,4)                       GRIDPP.19    
     :         ,SSBL(IGC),SHBL(IGC),SLBL(IGC),RRCR(IGC),RRLR(IGC)            GRIDPP.20    
     :         ,rflux(igc,6),sfld(igc,6),cld(igc,4)                          GRIDPP.21    
C                                                                            GRIDPP.22    
      COMMON/PHYS/  LBL,LVD,LCR,LLR,LRD,LCUBM,LCBADJ                         PHYSCA.2     
     :              ,TSTAR(IGC,JG),QSTAR(IGC,JG),FRAD(JG,NHEM)               PHYSCA.3     
     :              ,TSTARO(IGC,JG),TDEEPO(IGC,JG),smstar(igc,jg)            PHYSCA.4     
     :              ,tdeep(igc,jg),hsnow(igc,jg),sqstar(igc,jg)              PHYSCA.5     
     :              ,SALB(IGC,JG),SBAL(IGC,JG),BLCD(IGC)                     PHYSCA.6     
     :              ,SVEGE(IGC,JG),CD,DRAG,BLVAD,BLA,BLRH,BLVB(IGC)          PHYSCA.7     
     :              ,AKVV,AKTV,AKQV,ESCONA,ESCONB,EPSIQ,CTQ,CCC              PHYSCA.8     
     : ,ctqi,sdsn,shcs,shcsp,shcsn,skse,sksn,slhf,sd1,sd2,sdw                PHYSCA.9     
     :        ,ssmc,sdsnd,LSL,sasnow,saice,shsstar,shsmax                    PHYSCA.10    
     :     ,LOC,SHCO,SHCI,LNOICE,LOLDBL,LCOND,LNNSK,ITSLL,ITSLO              PHYSCA.11    
     :              ,CCR,RCON,DTBUOY,TSLA,TSLB,TSLC,TSLD,CUT1,CUT2           PHYSCA.12    
     :              ,NLCR,NCUTOP,CURHM,AKTC,AKQC,CUBMT,CBADJT,CBADJP         PHYSCA.13    
     :              ,SKAP(NL),SK(NLM),FWS(NL),CLR(NL),FB(NLM)                PHYSCA.14    
     :              ,TTDC(NL),QTDC(NL),TTMC(NL),QTMC(NL),TC(NL),QC(NL)       PHYSCA.15    
     :              ,CTCR(NL,NHEM),CTLR(NL,NHEM),NAVRD,NAVWT,DELT2C          PHYSCA.16    
      LOGICAL LBL,LVD,LCR,LLR,LRD,LCUBM,LCBADJ,LSL,LOC                       PHYSCA.17    
     :       ,LNOICE,LOLDBL,LCOND,LNNSK                                      PHYSCA.18    
C                                                                            PHYSCA.19    
C                                                                            XTRAP.2     
C     Setup moisture variables by equivilencing them to                      XTRAP.3     
C     Tracer No. 1                                                           XTRAP.4     
C                                                                            XTRAP.5     
      REAL QG(IGC,NL),QNLG(IGC,NL),QTLR(IGC,NL),QTCR(IGC,NL)                 XTRAP.6     
      EQUIVALENCE (QG(1,1),TRAG(1,1,1)) , (QNLG(1,1),TRANLG(1,1,1))          XTRAP.7     
     *            ,(QTLR(1,1),UTRAG(1,1,1)),(QTCR(1,1),VTRAG(1,1,1))         XTRAP.8     
C                                                                            XTRAP.9     
       COMMON/CPIERS/ICFLAG(IGC,5,2),CFRAC(IGC,5),PNET(IGC,JG)               CPIERS.2     
     :               ,SNET(IGC,JG),RRFLUX(IGC,JG,6)                          CPIERS.3     
     :               ,TTSW(IGC,NL),TTLW(IGC,NL)                              CPIERS.4     
C                                                                            LSCRN.22    
      REAL DQDT(NL)                                                          LSCRN.23    
C                                                                            LSCRN.24    
      DO 800 IHEM=1,NHEM                                                     LSCRN.25    
        IOFM=(IHEM-1)*MGPP                                                   LSCRN.26    
        DO 100 I=1,MG                                                        LSCRN.27    
          J=I+IOFM                                                           LSCRN.28    
          ESCON=1./PLG(J)                                                    LSCRN.29    
          DO 20 L=1,NL                                                       LSCRN.30    
            QS=ESCON*PQSAT(TG(J,L))/SIGMA(L)                                 LSCRN.31    
C LAYER CLOUD , High, middle, low.                                           LSCRN.32    
C Picks level (within low, mid, high) with largest RH                        LSCRN.33    
C and puts cloud there                                                       LSCRN.34    
C                                                                            LSCRN.35    
            RH=QG(J,L)/QS  ! relative humidity                               LSCRN.36    
            IF (RH.GT.0.8) THEN                                              LSCRN.37    
              CFR=((RH-0.8)/0.2)**2   ! cloud fraction mid/low/high cloud    LSCRN.38    
              IF (CFR.GT.1.0) CFR=1.0                                        LSCRN.39    
C high cloud                                                                 LSCRN.40    
              IF (SIGMA(L).GT.0.12.AND.SIGMA(L).LE.0.35) THEN                LSCRN.41    
                IF (CFR.GT.CFRAC(J,3)) THEN                                  LSCRN.42    
                  ICFLAG(J,3,1)=L                                            LSCRN.43    
                  ICFLAG(J,3,2)=L                                            LSCRN.44    
                  CFRAC(J,3)=CFR                                             LSCRN.45    
                ENDIF                                                        LSCRN.46    
              ENDIF                                                          LSCRN.47    
c mid cloud                                                                  LSCRN.48    
              IF (SIGMA(L).GT.0.35.AND.SIGMA(L).LE.0.70) THEN                LSCRN.49    
                IF (CFR.GT.CFRAC(J,2)) THEN                                  LSCRN.50    
                  ICFLAG(J,2,1)=L                                            LSCRN.51    
                  ICFLAG(J,2,2)=L                                            LSCRN.52    
                  CFRAC(J,2)=CFR                                             LSCRN.53    
                ENDIF                                                        LSCRN.54    
              ENDIF                                                          LSCRN.55    
c low cloud not in level nl                                                  LSCRN.56    
              IF (SIGMA(L).GT.0.70.AND.L.LT.NL) THEN                         LSCRN.57    
                IF (CFR.GT.CFRAC(J,1)) THEN                                  LSCRN.58    
                  ICFLAG(J,1,1)=L                                            LSCRN.59    
                  ICFLAG(J,1,2)=L                                            LSCRN.60    
                  CFRAC(J,1)=CFR                                             LSCRN.61    
                ENDIF                                                        LSCRN.62    
              ENDIF                                                          LSCRN.63    
            ENDIF                                                            LSCRN.64    
            QEXS=QG(J,L)-QS                                                  LSCRN.65    
C     Choose appropriate value of latent heat based on ground T              LSCRN.66    
c     ie, we assume it snows if the ground is colder than 273.15K            LSCRN.67    
            if (tstar(j,jh).gt.0.363224029) then                             LSCRN.68    
              ctquse=ctq                                                     LSCRN.69    
            else                                                             LSCRN.70    
              ctquse=ctqi                                                    LSCRN.71    
            endif                                                            LSCRN.72    
            QEX=QEXS/(1.0+CTQUSE*QS*ESCONB/(TG(J,L)*TG(J,L)))                LSCRN.73    
            IF (QEXS.LT.0.0) THEN                                            LSCRN.74    
              QEX=0.0                                                        LSCRN.75    
            END IF                                                           LSCRN.76    
            IF (QEXS.GE.0.0) THEN                                            LSCRN.77    
              CTLR(L,IHEM)=CTLR(L,IHEM)+1.0                                  LSCRN.78    
            END IF                                                           LSCRN.79    
            DQDT(L)=-QEX/DELT2C                                              LSCRN.80    
            QTLR(J,L)=QTLR(J,L)+DQDT(L)                                      LSCRN.81    
            TTLR(J,L)=-CTQUSE*DQDT(L)                                        LSCRN.82    
            QG(J,L)=QG(J,L)-QEX                                              LSCRN.83    
            TG(J,L)=TG(J,L)+CTQUSE*QEX                                       LSCRN.84    
   20     CONTINUE                                                           LSCRN.85    
          RRLR(J)=-SDOT(NL,DQDT,1,CLR,1)*PLG(J)                              LSCRN.86    
  100   CONTINUE                                                             LSCRN.87    
  800 CONTINUE                                                               LSCRN.88    
      RETURN                                                                 LSCRN.89    
      END                                                                    LSCRN.90    
